﻿Imports System.Text
Imports Microsoft.VisualStudio.TestTools.UnitTesting
Imports System.Threading

Namespace Evolve.WindowsAzure.Tests
    <TestClass()>
    Public Class PollingReleaseTest
        <TestMethod()>
        Public Sub Test_Polling_Release_Works_On_Release()
            ' Use a mock global flag rather than actual storage :)
            Dim mock As New MockGlobalFlag()
            Dim mre As New ManualResetEvent(False)
            ' Kick off on another polling on another thread to allow the Test thread to monitor
            CType(New Thread(CType(
                             Sub()
                                 Dim release As New PollingRelease(mock, 1)
                                 release.Wait()
                                 mre.Set()
                             End Sub, ThreadStart)), Thread).Start()
            ' this should release the polling wait
            mock.Flag = True
            Assert.IsTrue(mre.WaitOne(100), "Wait failed, should have been Set() by the PollingRelease thread but wasn't")
        End Sub

        <TestMethod()>
        Public Sub Test_Polling_Release_Blocks_On_No_Release()
            ' Use a mock global flag rather than actual storage :)
            Dim mock As New MockGlobalFlag()
            Dim mre As New ManualResetEvent(False)
            ' Kick off on another polling on another thread to allow the Test thread to monitor
            CType(New Thread(CType(Sub()
                                       Dim release As New PollingRelease(mock, 1)
                                       release.Wait()
                                       mre.Set()
                                   End Sub, ThreadStart)), Thread).Start()
            Assert.IsFalse(mre.WaitOne(100), "Wait let us through, should have paused for 10ms and failed to receive signal")
        End Sub

    End Class

    Public Class MockGlobalFlag
        Implements IGlobalFlag
        Private _Flag As Boolean
        Public Property Flag() As Boolean
            Get
                Return _Flag
            End Get
            Set(ByVal value As Boolean)
                _Flag = value
            End Set
        End Property

        Public Function GetFlag() As Boolean Implements IGlobalFlag.GetFlag
            Return Flag
        End Function

        Public Sub SetFlag(ByVal status As Boolean) Implements IGlobalFlag.SetFlag
            Flag = status
        End Sub
    End Class

End Namespace
