﻿Imports System.Text
Imports System.Threading

Namespace Evolve.WindowsAzure
    ''' <summary>
    ''' Polls a global flag at a fixed interval to check whether any callers blocked on the Wait method should be released.
    ''' </summary>
    Public Class PollingRelease
        Private ReadOnly _globalFlag As IGlobalFlag
        Private ReadOnly _intervalMilliseconds As Integer

        Public Sub New(ByVal globalFlag As IGlobalFlag, ByVal intervalMilliseconds As Integer)
            _globalFlag = globalFlag
            _intervalMilliseconds = intervalMilliseconds
        End Sub

        Public Sub Wait()
            Do While Not _globalFlag.GetFlag()
                Thread.Sleep(_intervalMilliseconds)
            Loop
        End Sub
    End Class
End Namespace
